/* vypocet hodnoty funkce sin(x)
   pomoci Taylorova rozvoje

   sin(x)=x -x3/3! +x5/5! -x7/7! +...

*/

#include <stdio.h>
#include <math.h>

int main()
{
 double x;         /* uhel v radianech   */
 double eps=1E-6;  /* presnost vypoctu   */
 double y;         /* vysledek - sin(x)  */
 double Q;         /* hodnota i-teho clenu rady */
 int    i;         /* i-ty clen Taylorovy rady  */

 x=M_PI/3.0;    /* uhel 60 stupnu */

 putchar('\n'); /*odradkovani*/

 y=x;
 Q=x;
 i=1;   /* finta: (i+1)-ni clen rady dostaneme z i-teho vynasobenim (x*x)/(2*i)/(2*i+1), nulty clen roven x */

 while (fabs(Q)>eps) {
     printf("y=%0.6f Q=%0.6f\n", y, Q);
   Q=-Q*x*x/(2*i)/(2*i+1);
   y=y+Q;
   i++;
   }

 printf("\n%.8f sin vypocteny Taylorovym rozvojem (%d clenu)", y, i);
 printf("\n%.8f sin vypocteny knihovni fci sin", sin(x));
 getchar();
 return 0;
}

